unit hiShareWare;

interface

uses Kol,windows,Share,Debug;

type
  THIShareWare = class(TDebug)
   private
   FTimer:PTimer;
   AutoStop:integer;
   FAtom:string;
   FMsgStart:string;
   FMsgStop:string;
   FMsgDebug:string;
   FEnableTimer:boolean;
   FTime:integer;

   procedure SetAtom(Value: string);
   procedure SetMsgStart(Value: string);
   procedure SetMsgStop(Value: string);
   procedure SetMsgDebug(Value: string);
   procedure SetEnableTimer(Value: boolean);
   procedure SetTime(Value: integer);

   public
    _event_onTime:THI_Event;

    destructor Destroy; override;
    procedure Init;
    procedure OnTimer(Obj:PObj);
    function isDebugProc:boolean;

    property _prop_Atom:string write SetAtom;
    property _prop_MessageStart:string write SetMsgStart;
    property _prop_MessageStop:string write SetMsgStop;
    property _prop_MessageDebug:string write SetMsgDebug;
    property _prop_EnableTimer:boolean write SetEnableTimer;
    property _prop_Time:integer write SetTime;

  end;

function MessageBoxTimeOut(hWnd: HWND; lpText: PChar;
         lpCaption: PChar; uType: UINT; wLanguageId: WORD;
         dwMilliseconds: DWORD): Integer; stdcall;
         external user32 name 'MessageBoxTimeoutA';


implementation

procedure THIShareWare.SetAtom;
begin
  FAtom := Value;
end;

procedure THIShareWare.SetMsgStart;
begin
  FMsgStart := Value;
end;

procedure THIShareWare.SetMsgStop;
begin
  FMsgStop := Value;
end;

procedure THIShareWare.SetMsgDebug;
begin
  FMsgDebug := Value;
end;

procedure THIShareWare.SetEnableTimer;
begin
  FEnableTimer := Value;
end;

procedure THIShareWare.SetTime;
begin
  FTime := Value;
  Init;
end;

function THIShareWare.isDebugProc;
type
  TDebugProc = function: boolean; stdcall;
var
  Kernel32: HMODULE;
  DebugProc: TDebugProc;
begin
  Result := False;
  Kernel32 := GetModuleHandle('kernel32.dll');
  if Kernel32 <> 0 then
  begin
    @DebugProc := GetProcAddress(Kernel32, 'IsDebuggerPresent');
    if Assigned(DebugProc) then
      Result := DebugProc;
  end;
end;

procedure THIShareWare.OnTimer;
begin
  dec(AutoStop);
  if AutoStop = 1 then FTimer.Interval := 1000;
  if AutoStop = -60 then
    begin
      FTimer.Enabled := false;
      if FMsgStop <> '' then
      //MessageBox(ReadHandle,PChar(FMsgStop),
      //  'Message', MB_OK or MB_ICONASTERISK);
      MessageBoxTimeout(ReadHandle, PChar(FMsgStop),
        'Message', MB_OK or MB_SYSTEMMODAL or MB_ICONASTERISK, 0, 30000);
      Halt;
    end;
  if AutoStop > 1 then
  _hi_onEvent(_event_onTime, 'Automatic closing in ' + int2str(AutoStop) + ' minutes')
  else _hi_onEvent(_event_onTime, 'Automatic closing in ' + int2str(60 + AutoStop) + ' seconds');
end;

procedure THIShareWare.Init;
begin
 if isDebugProc then
 begin
   if FMsgDebug <> '' then  begin
     MessageBoxTimeout(ReadHandle, PChar(FMsgDebug),
          'Message', MB_OK or MB_SYSTEMMODAL or MB_ICONASTERISK, 0, 5000);
     Halt; end else Halt;
 end;
 if GlobalFindAtom(PChar(FAtom)) = 0 then
   begin
     GlobalAddAtom(PChar(FAtom));
     if FMsgStart <> '' then
     ShowMessage(FMsgStart);
     if FEnableTimer then
       begin
         AutoStop := FTime;
         FTimer := NewTimer(AutoStop*60000);
         FTimer.Interval := 60000;
         FTimer.Enabled := true;
         FTimer.OnTimer := onTimer;
       end;
   end
 else if FMsgStop <> '' then
        begin
          ShowMessage(FMsgStop);
          Halt;
        end else Halt;
end;

destructor THIShareWare.Destroy;
begin
   FTimer.Free;
   inherited Destroy;
end;

end.
